Package net.sf.saxon.pattern

## Class AnyNodeTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.AnyNodeTest

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `QNameTest`, `ItemType`, `ItemType.WithSequenceTypeCache`

      public final class AnyNodeTest
      extends NodeTest
      implements QNameTest

  NodeTest is an interface that enables a test of whether a node has a particular name and type. An AnyNodeTest matches any node.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `exportQNameTest()` | Export the QNameTest as a string for use in a SEF file (typically in a catch clause).
    `java.lang.String` | `generateJavaScriptNameTest​(int targetVersion)` | Generate Javascript code to test if a name matches the test.
    `double` | `getDefaultPriority()` | Determine the default priority of this node test when used on its own as a Pattern
    `static AnyNodeTest` | `getInstance()` | Get an instance of AnyNodeTest
    `java.util.function.IntPredicate` | `getMatcher​(NodeVectorTree tree)` | Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `matches​(StructuredQName qname)` | Test whether this QNameTest matches a given QName
    `boolean` | `test​(NodeInfo node)` | Test whether this node test is satisfied by a given node.
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, explainMismatch, getAtomizedItemType, getBasicAlphaCode, getContentType, getFingerprint, getGenre, getMatchingNodeName, getPrimitiveItemType, getPrimitiveType, getRequiredNodeNames, isAtomicType, isAtomizable, isNillable, isPlainType, matches, one, oneOrMore, toShortString, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType, toExportString`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Method Detail

    - #### getInstance

          public static AnyNodeTest getInstance()

      Get an instance of AnyNodeTest
      Returns:
        the singleton instance of this class

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Returns:
        the smallest UType that subsumes this item type

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node test

    - #### getMatcher

          public java.util.function.IntPredicate getMatcher​(NodeVectorTree tree)

      Description copied from class: `NodeTest`
      Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test. (Calling this matcher must give the same result as calling `matchesNode(tree.getNode(nodeNr))`, but it may well be faster).
      Overrides:
        `getMatcher` in class `NodeTest`
      Parameters:
        `tree` - the tree against which the returned function will operate
      Returns:
        an IntPredicate; the matches() method of this predicate takes a node number as input, and returns true if and only if the node identified by this node number matches the node test.

    - #### test

          public boolean test​(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Specified by:
        `test` in interface `java.util.function.Predicate<NodeInfo>`
      Overrides:
        `test` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### matches

          public boolean matches​(StructuredQName qname)

      Test whether this QNameTest matches a given QName
      Specified by:
        `matches` in interface `QNameTest`
      Parameters:
        `qname` - the QName to be matched
      Returns:
        true if the name matches, false if not

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### exportQNameTest

          public java.lang.String exportQNameTest()

      Export the QNameTest as a string for use in a SEF file (typically in a catch clause).
      Specified by:
        `exportQNameTest` in interface `QNameTest`
      Returns:
        a string representation of the QNameTest, suitable for use in export files. The format is a sequence of alternatives separated by vertical bars, where each alternative is one of '*', '*:localname', 'Q{uri}*', or 'Q{uri}local'.

    - #### generateJavaScriptNameTest

          public java.lang.String generateJavaScriptNameTest​(int targetVersion)

      Generate Javascript code to test if a name matches the test.
      Specified by:
        `generateJavaScriptNameTest` in interface `QNameTest`
      Parameters:
        `targetVersion` - The version of Saxon-JS being targeted
      Returns:
        JS code as a string. The generated code will be used as the body of a JS function in which the argument name "q" is an XdmQName object holding the name. The XdmQName object has properties uri and local.